    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ------------------------------------
    028     * BoxAndWhiskerXYToolTipGenerator.java
    029     * ------------------------------------
    030     * (C) Copyright 2003-2005, by David Browning and Contributors.
    031     *
    032     * Original Author:  David Browning;
    033     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034     *
    035     * $Id: BoxAndWhiskerXYToolTipGenerator.java,v 1.4.2.1 2005/10/25 20:49:02 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 05-Aug-2003 : Version 1, contributed by David Browning (DG);
    040     * 13-Aug-2003 : Implemented Cloneable (DG);
    041     * 28-Aug-2003 : Updated for changes in dataset API (DG);
    042     * 25-Feb-2004 : Renamed XYToolTipGenerator --> XYItemLabelGenerator (DG);
    043     * 27-Feb-2004 : Renamed BoxAndWhiskerItemLabelGenerator -->
    044     *               BoxAndWhiskerXYItemLabelGenerator, and modified to use
    045     *               MessageFormat (DG);
    046     * 15-Jul-2004 : Switched getX() with getXValue() and getY() with
    047     *               getYValue() (DG);
    048     *
    049     */
    050
    051    package org.jfree.chart.labels;
    052
    053    import java.io.Serializable;
    054    import java.text.DateFormat;
    055    import java.text.MessageFormat;
    056    import java.text.NumberFormat;
    057    import java.util.Date;
    058
    059    import org.jfree.data.statistics.BoxAndWhiskerXYDataset;
    060    import org.jfree.data.xy.XYDataset;
    061
    062    /**
    063     * An item label generator for plots that use data from a
    064     * {@link BoxAndWhiskerXYDataset}.
    065     * <P>
    066     * The tooltip text and item label text are composed using a
    067     * {@link java.text.MessageFormat} object, that can aggregate some or all of
    068     * the following string values into a message.
    069     * <table>
    070     * <tr><td>0</td><td>Series Name</td></tr>
    071     * <tr><td>1</td><td>X (value or date)</td></tr>
    072     * <tr><td>2</td><td>Mean</td></tr>
    073     * <tr><td>3</td><td>Median</td></tr>
    074     * <tr><td>4</td><td>Minimum</td></tr>
    075     * <tr><td>5</td><td>Maximum</td></tr>
    076     * <tr><td>6</td><td>Quartile 1</td></tr>
    077     * <tr><td>7</td><td>Quartile 3</td></tr>
    078     * </table>
    079     *
    080     * @author David Browning
    081     */
    082    public class BoxAndWhiskerXYToolTipGenerator extends StandardXYToolTipGenerator
    083                                                 implements XYToolTipGenerator,
    084                                                            Cloneable,
    085                                                            Serializable {
    086
    087        /** For serialization. */
    088        private static final long serialVersionUID = -2648775791161459710L;
    089
    090        /** The default tooltip format string. */
    091        public static final String DEFAULT_TOOL_TIP_FORMAT
    092            = "X: {1} Mean: {2} Median: {3} Min: {4} Max: {5} Q1: {6} Q3: {7} ";
    093
    094        /**
    095         * Creates a default item label generator.
    096         */
    097        public BoxAndWhiskerXYToolTipGenerator() {
    098            super(
    099                DEFAULT_TOOL_TIP_FORMAT,
    100                NumberFormat.getInstance(), NumberFormat.getInstance()
    101            );
    102        }
    103
    104        /**
    105         * Creates a new item label generator.  If the date formatter is not
    106         * <code>null</code>, the x-values will be formatted as dates.
    107         *
    108         * @param toolTipFormat  the tool tip format string (<code>null</code> not
    109         *                       permitted).
    110         * @param numberFormat  the number formatter (<code>null</code> not
    111         *                      permitted).
    112         * @param dateFormat  the date formatter (<code>null</code> permitted).
    113         */
    114        public BoxAndWhiskerXYToolTipGenerator(String toolTipFormat,
    115                                               DateFormat dateFormat,
    116                                               NumberFormat numberFormat) {
    117
    118            super(toolTipFormat, dateFormat, numberFormat);
    119
    120        }
    121
    122        /**
    123         * Creates the array of items that can be passed to the
    124         * {@link MessageFormat} class for creating labels.
    125         *
    126         * @param dataset  the dataset (<code>null</code> not permitted).
    127         * @param series  the series (zero-based index).
    128         * @param item  the item (zero-based index).
    129         *
    130         * @return The items (never <code>null</code>).
    131         */
    132        protected Object[] createItemArray(XYDataset dataset, int series,
    133                                           int item) {
    134            Object[] result = new Object[8];
    135            result[0] = dataset.getSeriesKey(series).toString();
    136            Number x = dataset.getX(series, item);
    137            if (getXDateFormat() != null) {
    138                result[1] = getXDateFormat().format(new Date(x.longValue()));
    139            }
    140            else {
    141                result[1] = getXFormat().format(x);
    142            }
    143            NumberFormat formatter = getYFormat();
    144
    145            if (dataset instanceof BoxAndWhiskerXYDataset) {
    146                BoxAndWhiskerXYDataset d = (BoxAndWhiskerXYDataset) dataset;
    147                result[2] = formatter.format(d.getMeanValue(series, item));
    148                result[3] = formatter.format(d.getMedianValue(series, item));
    149                result[4] = formatter.format(d.getMinRegularValue(series, item));
    150                result[5] = formatter.format(d.getMaxRegularValue(series, item));
    151                result[6] = formatter.format(d.getQ1Value(series, item));
    152                result[7] = formatter.format(d.getQ3Value(series, item));
    153            }
    154            return result;
    155        }
    156
    157        /**
    158         * Tests if this object is equal to another.
    159         *
    160         * @param obj  the other object.
    161         *
    162         * @return A boolean.
    163         */
    164        public boolean equals(Object obj) {
    165            if (obj == this) {
    166                return true;
    167            }
    168            if (!(obj instanceof BoxAndWhiskerXYToolTipGenerator)) {
    169                return false;
    170            }
    171            return super.equals(obj);
    172        }
    173
    174    }